/*
 *       SmoothAlgorithms.mqh
 *   __\MQL5\Include
 */
//+------------------------------------------------------------------+
//|                                                        ParMA.mq5 |
//|          Parabolic approximation code: Copyright  2005, alexjou |
//|                               Copyright  2010, Nikolay Kositsin |
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
#property copyright "2010,   Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
#property version   "1.00"

//----     
#property indicator_chart_window
//----        
#property indicator_buffers 1
//----     
#property indicator_plots   1
//----     
#property indicator_type1   DRAW_LINE
//----        
#property indicator_color1 DodgerBlue

//----   
input int ParMAPeriod=13;    // ParMA
input int ParMAShift=0;      // ParMA    
input int ParMAPriceShift=0; // ParMA    

//---  
double ExtLineBuffer[];

double dPriceShift;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
  {
//----        
   string short_name="ParMA";
   IndicatorSetString(INDICATOR_SHORTNAME,short_name+"("+string(ParMAPeriod)+")");
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,ParMAPeriod);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----    ExtLineBuffer   
   SetIndexBuffer(0,ExtLineBuffer,INDICATOR_DATA);
//----       ParMAShift
   PlotIndexSetInteger(0,PLOT_SHIFT,ParMAShift);
//----     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//----    
   dPriceShift=_Point*ParMAPriceShift;
//----
  }
//+------------------------------------------------------------------+
//|   ParMA  SmoothAlgorithms.mqh         | 
//+------------------------------------------------------------------+ 
#include <SmoothAlgorithms.mqh> 
//+------------------------------------------------------------------+ 
//|  Moving Average                                                  |
//+------------------------------------------------------------------+
int OnCalculate (const int rates_total,     //       
                 const int prev_calculated, //       
                 const int begin,           //     
                 const double &price[]      //     
                 )
  {
//----       
   if(rates_total<begin+ParMAPeriod)
      return(0);

//----    
   int first,bar;

//----    first    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      first=begin; //      
      for(bar=0; bar<=begin; bar++)
         ExtLineBuffer[bar]=0;
     }
   else first=prev_calculated-1; //      

//----    CParMA   ParMASeries_Cls.mqh
   static CParMA ParMA1;

//----    
   for(bar=first; bar<rates_total; bar++)
     {
      //----   .    ParMASeries.  
      ExtLineBuffer[bar]=ParMA1.ParMASeries(begin,prev_calculated,rates_total,
                                            ParMAPeriod,price[bar],bar,false)+dPriceShift;
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
